from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC


class AuthenticationSettings(ConfigurationModelABC):
    def __init__(
        self,
        secret_key: str = None,
        issuer: str = None,
        audience: str = None,
        token_expire_time: int = None,
        refresh_token_expire_time: int = None,
    ):
        ConfigurationModelABC.__init__(self)

        self._secret_key = "" if secret_key is None else secret_key
        self._issuer = "" if issuer is None else issuer
        self._audience = "" if audience is None else audience
        self._token_expire_time = 0 if token_expire_time is None else token_expire_time
        self._refresh_token_expire_time = 0 if refresh_token_expire_time is None else refresh_token_expire_time

    @property
    def secret_key(self) -> str:
        return self._secret_key

    @property
    def issuer(self) -> str:
        return self._issuer

    @property
    def audience(self) -> str:
        return self._audience

    @property
    def token_expire_time(self) -> int:
        return self._token_expire_time

    @property
    def refresh_token_expire_time(self) -> int:
        return self._refresh_token_expire_time
