CREATE TABLE IF NOT EXISTS `CFG_TechnicianIdsHistory`
(
    `Id`    BIGINT(20)  NOT NULL,
    `TechnicianId` BIGINT NOT NULL,
    `Deleted` BOOL DEFAULT FALSE,
    `DateFrom` DATETIME(6) NOT NULL,
    `DateTo` DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_CFG_TechnicianIdsUpdate`;

CREATE TRIGGER `TR_CFG_TechnicianIdsUpdate`
    AFTER UPDATE
    ON `CFG_TechnicianIds`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_TechnicianIdsHistory` (
        `Id`,
        `TechnicianId`,
        `DateFrom`,
        `DateTo`
    )
    VALUES (
        OLD.Id,
        OLD.TechnicianId,
        OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_CFG_TechnicianIdsDelete`;

CREATE TRIGGER `TR_CFG_TechnicianIdsDelete`
    AFTER DELETE
    ON `CFG_TechnicianIds`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_TechnicianIdsHistory` (
        `Id`,
        `TechnicianId`,
        `Deleted`,
        `DateFrom`,
        `DateTo`
    )
    VALUES (
        OLD.Id,
        OLD.TechnicianId,
        TRUE,
        OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;