from cpl_core.database.context import DatabaseContextABC

from bot_data.model.level import Level
from bot_data.model.level_history import LevelHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class LevelQuery(DataQueryWithHistoryABC):
    def __init__(self, db: DatabaseContextABC):
        DataQueryWithHistoryABC.__init__(self, "Level", "LevelsHistory", LevelHistory, db)

        self.set_field("id", self.resolve_id)
        self.set_field("name", self.resolve_name)
        self.set_field("color", self.resolve_color)
        self.set_field("minXp", self.resolve_min_xp)
        self.set_field("permissions", self.resolve_permissions)
        self.set_field("server", self.resolve_server)

    @staticmethod
    def resolve_id(level: Level, *_):
        return level.id

    @staticmethod
    def resolve_name(level: Level, *_):
        return level.name

    @staticmethod
    def resolve_color(level: Level, *_):
        return level.color

    @staticmethod
    def resolve_min_xp(level: Level, *_):
        return level.min_xp

    @staticmethod
    def resolve_permissions(level: Level, *_):
        return level.permissions

    @staticmethod
    def resolve_server(level: Level, *_):
        return level.server
