from cpl_core.database.context import DatabaseContextABC

from bot_data.model.short_role_name_history import ShortRoleNameHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class ShortRoleNameQuery(DataQueryWithHistoryABC):
    def __init__(
        self,
        db: DatabaseContextABC,
    ):
        DataQueryWithHistoryABC.__init__(self, "ShortRoleName", "ShortRoleNamesHistory", ShortRoleNameHistory, db)

        self.set_field("id", lambda x, *_: x.id)
        self.set_field("shortName", lambda x, *_: x.short_name)
        self.set_field("roleId", lambda x, *_: x.role_id)
        self.set_field("roleName", lambda x, *_: x.role_name)
        self.set_field("position", lambda x, *_: x.position)
